# k Nearest Neighbour
library(caret)	# ClAssification and REgression Training
library(pROC)	# functii pt ROC curve
library(mlbench)  # seturi de date din UCI Machine Learning

## Exercitiu:  (a) kNN pt Breast Cancer data (din mlbench). 
# Variante: nominal vs numeric. 
# Analiza influentei standardizarii (centrare si scalare folosind abaterea standard)

data(BreastCancer)

# eliminare valori absente - kNN nu poate fi aplicat pt date cu valori lipsa 
BreastCancer <- na.omit(BreastCancer)

dataSet <- BreastCancer[,2:10]
dataClass <- BreastCancer[,11]

# transformare in valori numerice (daca e cazul)

# for (i in 1:(dim(dataSet)[2]))
#    dataSet[,i] <- as.numeric(dataSet[,i])

# partitionare in set antrenare (75%) si set testare (25%) 
inTrain <- createDataPartition(dataClass, p = 0.75, list = FALSE)
trainingSet <- dataSet[inTrain,]
testingSet <- dataSet[-inTrain,]
trainingClass <- dataClass[inTrain]
testingClass <- dataClass[-inTrain]

# model construction
bootstrappingControl <- trainControl(number = 100) # bootstrapping bazat pe 100 de repetari (default value:25)
knnFit <- train(trainingSet, trainingClass, method="knn", tuneLength = 10, trControl=bootstrappingControl, preProcess=c("center","scale"))
plot(knnFit)

# ??? Care este cea mai potrivita valoare pt k?  (indicatie:  utilizati knnFit$finalModel)

# testare
resTesting <- predict(knnFit, testingSet)
confusionMatrix(data = resTesting, reference = testingClass)

# construire model folosind validare incrucisata
CVcontrol <- trainControl(method="repeatedcv",repeats = 10)
knnFit2 <- train(trainingSet, trainingClass, method="knn", tuneLength = 10, trControl=CVcontrol)

dev.new()
plot(knnFit2)
resTesting2 <- predict(knnFit2, testingSet)
confusionMatrix(data = resTesting2, reference = testingClass)

# ??? este vreo diferenta intre cel mai bun model obtinut cu knnFit si cel cu  knnFit2?

# ROC curve + area under curve (curba ROC poate fi utilizata pentru clasificarea binara)
knnPredict <- predict(knnFit, testingSet, type="prob")
knnROC <- roc(testingClass,knnPredict[,"malignant"])  # clasa pozitiva trebuie specificata

# grafic ROC curve
plot(knnROC, type="S", print.thres= c(0.1,0.25,0.5,0.75,0.9))

# ??? ce valoare are AUC ?  (indicatie: analiza knnROC)

######################################################################
# ??? Tema: analizati influenta lui k utilizand functia "knn" din pachetul "class"
# obs: knn din pachetul class permite control asupra lui k
######################################################################
library(class)
# Indicatie:  kNN cu k=3; 
rezkNN <- knn(trainingSet, testingSet, trainingClass, k = 3, prob=TRUE)
confusionMatrix(data=rezkNN, reference=testingClass)
# TODO:  test pt k in {1,2,3,...20} + comparare performante
