library(caret)
library(mlbench)

#################################################
## Exercitiu:  (a) naiveBayes pt Breast Cancer data. 
# Varianta: date nominale
#################################################

data(BreastCancer)

# eliminare inregistrari cu valori lipsa 
# BreastCancer <- na.omit(BreastCancer)

dataSet <- BreastCancer[,2:10]
dataClass <- BreastCancer[,11]
inTrain <- createDataPartition(dataClass, p = 0.75, list = FALSE)

trainingSet <- dataSet[inTrain,]
testingSet <- dataSet[-inTrain,]

trainingClass <- dataClass[inTrain]
testingClass <- dataClass[-inTrain]

# construire clasificator (estimarea tuturor probabilitatilor conditionate)
# varianta: 10-fold cross-validation
nbfit <- train(trainingSet, trainingClass,'nb',trControl=trainControl(method='cv',number=10))

resTesting <- predict(nbfit$finalModel,testingSet)

# matrice de confuzie
table(predict(nbfit$finalModel,testingSet)$class,testingClass)

# matrice de confuzie + indicatori de performanta
confusionMatrix(data = resTesting$class, reference = testingClass)

#####################################################################
# ??? Tema:  analizati impactul eliminarii inregistrarilor cu valori absente
#####################################################################


###########################
# ## Exercitiu:  (b) naiveBayes pt Titanic dataset. 
###########################

trainTitanic <- read.csv("datasets/trainTitanic.csv")
testTitanic <- read.csv("datasets/testTitanic.csv")

trainingSet <- trainTitanic[,c(3,5,7,8)]  # naive Bayes nu poate procesa variabile numerice cu valori continue (e.g. age, fare)
testingSet <- testTitanic[,c(2,4,6,7)]    # atributele sunt renumerotate pt ca setul de testare nu contine atributul Survived 

trainingClass <- as.factor(trainTitanic$Survived)
#testingClass <- as.factor(testTitanic$Survived) # in testTitanic nu exista atribut Survived

nbfit <- train(trainingSet, trainingClass,'nb',trControl=trainControl(method='cv',number=10))

# vizualizare componente model
nbfit$finalModel

# aplicarea clasificatorului
# resTesting <- predict(nbfit$finalModel,testingSet)
resTesting <- predict(nbfit$finalModel,trainingSet)


# matrice de confuzie + indicatori de performanta (pe setul de antrenare)
confusionMatrix(data = resTesting$class, reference = trainingClass)

