# Support Vector Machine

library(caret)	# ClAssification and REgression Training
library(pROC)	# functions for ROC curve
library(mlbench)  # datasets from UCI Machine Learning

## Exercitiu:  (a) svm-based classification of Breast Cancer data. 
data(BreastCancer)

# eliminare valori lipsa 
BreastCancer <- na.omit(BreastCancer)

dataSet <- BreastCancer[,2:10]
dataClass <- BreastCancer[,11]

# conversie in numeric  

for (i in 1:(dim(dataSet)[2]))
  dataSet[,i] <- as.numeric(dataSet[,i])

# partitionare
inTrain <- createDataPartition(dataClass, p = 0.75, list = FALSE)
trainingSet <- dataSet[inTrain,]
testingSet <- dataSet[-inTrain,]
trainingClass <- dataClass[inTrain]
testingClass <- dataClass[-inTrain]

# cross validation with 10 folds
cvControl <- trainControl(method = 'cv', number = 10, classProbs = TRUE, verboseIter = TRUE) 

# training the SVM using a radial kernel - 5 values of the parameter C (see details in Lect 5-6) are analyzed and the best model is selected
svmFit <- train(trainingSet, trainingClass, method = "svmRadial", tuneLength = 5, trControl = cvControl, preProcess=c("center","scale"))

# ??? analizati influenta parametrului C utilizat in construirea modelului (tuneLength = 5, tuneLength = 10 etc)

svmFit$finalModel

# vizualizare acuratete in fctie de valoarea lui C
plot(svmFit)

# testare - determinare rezultate ca probabilitati
resTesting <- predict(svmFit, testingSet, type="prob")

# testare - determinare rezultate ca variabile nominale
resTestingNominalDirect <- predict(svmFit, testingSet, type="raw")

# Analyze the performance:  confusion matrix, performance measures, ROC
svmCM <- confusionMatrix(data = resTestingNominalDirect, reference = testingClass)

svmROC <- roc(testingClass,resTesting[,"malignant"]) 
plot(svmROC, type="S", print.thres=c(0.1, 0.2, 0.5, 0.7, 0.9))

# ??? Care e valoarea pt AUC (analizati svmROC); Ce se poate spune despre clasificator?

# ??? Tema: analizati influenta urmatoarelor functii nucleu:  svmRadial, svmPoly, svmLinear
